/*
    Copyright (C) 1996 Alistair Conkie
 
    You may distribute under the terms of the GNU General Public
    Licence as specified in the README file.
*/
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "regexp.h"
#include "rule_engine.h"
#include "t2s.h"
#include "prototypes.h"

void rule_exec(int type,int nrules, RULE *rule, char *input)
/* type is compact/expanded -- not yet implemented  */
{

	int i;
	int lmatch = 0, rmatch = 0;
	char *prev;
	char deft[2];
	char *nb = input;

	char ib[500];	/* BAD BAD BAD  */

	/* Now we are ready to apply the rules  */
	/* for now there is not compactify/decompactify  */
	/* for now there is no null target  */
	/* and what about a stepping through version -- should be quite easy  */

	prev = strdup(input);

	prev[0] = '\0';
	ib[0] = '\0';
	deft[1] = '\0';
	while(strlen(input)) {
		for(i=0;i<nrules;i++) {
			lmatch = 0;
			rmatch = 0;
			if(!strncmp(input,rule[i].target,strlen(rule[i].target))) {
				/* candidate for rule match  */
				lmatch = regexec(rule[i].lc,prev);
				rmatch = regexec(rule[i].rc,input+strlen(rule[i].target));
				if(lmatch && rmatch) {
					strcat(ib,rule[i].output);
					input += strlen(rule[i].target);
					strcat(prev,rule[i].target);
					break;
				}
			}
		}
		if(lmatch && rmatch) {
			;
		} else if(type | SAME ) {
			*deft = *input++;
			strcat(ib,deft);
			strcat(prev,deft);
		} else {
			free(prev);
			strcat(nb,"");
			return;
		}
	}
	free(prev);
	strcpy(nb,ib);
}
